/**
  临时存储
 */
 
define(function(require, exports, module) {
  
  var myCookie = {
    set : function(name, value){
      var day = 30;
      var exp = new Date();
      exp.setTime(exp.getTime() + day*24*60*60*1000);
      document.cookie = name + "=" + escape (value) + ";expires=" + exp.toGMTString();
    },
    
    get : function(name){
      var arrStr = document.cookie.split("; ");
      var i = 0, len = arrStr.length;
      for(; i < len; i++){
        var temp = arrStr[i].split("=");
        if(temp[0] == name) return unescape(temp[1]);
      }
    },

    del : function(name){
      var exp = new Date();
      exp.setTime(exp.getTime() - 1);
      var cval = this.get(name);
      if(typeof cval != "undefined") document.cookie = name + "=" + cval + ";expires=" + exp.toGMTString();
    }
  };
  
  // 本地存储，如果本地存储不支持，使用cookie
  var myStore = (function(){
    if( window.localStorage ){
      return {
        set : function(name, value){
          localStorage.setItem(name, value.toString());
        },
        
        get : function(name){
          return localStorage.getItem(name);
        },
        
        del : function(name){
          localStorage.removeItem(name);
        }
      };
      
    }else{
      return {
        set : function(name, value){
          myCookie.set(name, value.toString());
        },
        
        get : function(name){
          return myCookie.get(name);
        },
        
        del : function(name){
          myCookie.del(name);
        }
      };
    }
    
  })();
  
  module.exports = myStore;

});

